//	Copyright (C) 2011 Michael McMaster <michael@codesrc.com>
//
//	This file is part of glBoy.
//
//	glBoy is free software: you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation, either version 3 of the License, or
//	(at your option) any later version.
//
//	glBoy is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with glBoy.  If not, see <http://www.gnu.org/licenses/>.

#ifndef GLBOY_DAA_HH
#define GLBOY_DAA_HH

#include "glBoy.hh"
#include "ALU.hh"
#include "Registers.hh"

namespace glBoy
{

// Algorithm taken from
// http://wikiti.brandonw.net/?title=Z80_Instruction_Set
inline uint8_t DAA(uint8_t a, Flags& flags)
{
	uint8_t result(a);

	if (flags.N)
	{
		if (flags.H || ((a & 0xf) > 9)) result -= 6;
		if (flags.C || (a > 0x99)) result -= 0x60;
	}
	else
	{
		if (flags.H || ((a & 0xf) > 9)) result += 6;
		if (flags.C || (a > 0x99)) result += 0x60;
	}

	flags.byte = // S Z U5 H U3 P N C
		(result & 0x80) |
		((result == 0) ? 0x40 : 0) |
		// U5
		((a ^ result) & 0x10) |
		// U3
		flags.P |
		(flags.N ? 0x2 : 0) |
		((flags.C || (a > 0x99)) ? 1 : 0);

	// TODO U3 U5

	return result;
}

} // namespace

#endif
