//	Copyright (C) 2011 Michael McMaster <michael@codesrc.com>
//
//	This file is part of glBoy.
//
//	glBoy is free software: you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation, either version 3 of the License, or
//	(at your option) any later version.
//
//	glBoy is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with glBoy.  If not, see <http://www.gnu.org/licenses/>.

#ifndef GLBOY_RAM_HH
#define GLBOY_RAM_HH

#include "glBoy.hh"
#include "MemoryMap.hh"

#include <vector>
namespace glBoy
{

class RAM : public MemoryMap::Memory
{
public:
	RAM(uint16_t size);
	virtual uint8_t read8(uint16_t address);
	virtual void write8(uint16_t address, uint8_t value);
	virtual void copy(uint8_t* dest, uint16_t address, int bytes);


private:
	std::vector<uint8_t> m_mem;
};

} // namespace glBoy

#endif

