//	Copyright (C) 2011 Michael McMaster <michael@codesrc.com>
//
//	This file is part of glBoy.
//
//	glBoy is free software: you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation, either version 3 of the License, or
//	(at your option) any later version.
//
//	glBoy is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with glBoy.  If not, see <http://www.gnu.org/licenses/>.

#include "glBoy.hh"
#include "ROM.hh"
#include "Log.hh"

#include <string.h>

#include <cassert>

using namespace glBoy;

ROM::ROM(const uint8_t* data, uint16_t size) :
	m_mem(data, data + size)
{
}

uint8_t
ROM::read8(uint16_t address)
{
	return m_mem[address];
}

void
ROM::write8(uint16_t address, uint8_t)
{
	//assert(false);
	Log::Instance()(Log::DBG_MEMORY) <<
		"Attempt to write to read-only address " << address <<
		std::endl;
}

void
ROM::copy(uint8_t* dest, uint16_t address, int bytes)
{
	memcpy(dest, &m_mem[0] + address, bytes);
}

