//	Copyright (C) 2011 Michael McMaster <michael@codesrc.com>
//
//	This file is part of glBoy.
//
//	glBoy is free software: you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation, either version 3 of the License, or
//	(at your option) any later version.
//
//	glBoy is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with glBoy.  If not, see <http://www.gnu.org/licenses/>.

#ifndef GLBOY_HH
#define GLBOY_HH

#include <cstdint>
#include <iostream>

namespace glBoy
{
	typedef uint8_t op8_t;
	typedef uint8_t op16_t;

	typedef uint8_t reg8_t;
	typedef uint16_t reg16_t;

	typedef uint16_t address_t;

	typedef bool bit;

	typedef int64_t cycle_t;

	#if !(defined(HOST_LITTLE_ENDIAN) || defined(HOST_BIG_ENDIAN))
		#warning Assuming little-endian
		#define HOST_LITTLE_ENDIAN
	#endif

}

#endif

