//	Copyright (C) 2011 Michael McMaster <michael@codesrc.com>
//
//	This file is part of glBoy.
//
//	glBoy is free software: you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation, either version 3 of the License, or
//	(at your option) any later version.
//
//	glBoy is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with glBoy.  If not, see <http://www.gnu.org/licenses/>.

#ifndef GLBOY_HQ4X_HH
#define GLBOY_HQ4X_HH

#include <cstdint>

#include <GL/gl.h>

namespace glBoy
{
	class Hq4x
	{
	public:
		Hq4x(size_t textureWidth, size_t textureHeight);

		void prepareShader(GLuint texture);

	private:
		enum Diff { Diff_2_6 = 1, Diff_6_8 = 2, Diff_8_4 = 4, Diff_4_2 = 8 };

		uint32_t* getHq4xLookupTable() const;

		int m_textureWidth;
		int m_textureHeight;

		GLint m_vertexShader;
		GLint m_fragShader;
		GLint m_program;
		GLuint m_lookupTexture;
	};
}

#endif

